import { Injectable, ComponentFactoryResolver, ɵɵdefineInjectable, ɵɵinject, Component, Input, Directive, ViewContainerRef, ViewChild, NgModule } from '@angular/core';
import { Subject } from 'rxjs';
import { trigger, state, style, transition, animate } from '@angular/animations';
import { CommonModule } from '@angular/common';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/toast.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Toast {
    /**
     * @param {?} component
     * @param {?} data
     * @param {?=} viewRef
     */
    constructor(component, data, viewRef) {
        this.component = component;
        this.data = data;
        this.viewRef = viewRef;
    }
}
if (false) {
    /** @type {?} */
    Toast.prototype.component;
    /** @type {?} */
    Toast.prototype.data;
    /** @type {?} */
    Toast.prototype.viewRef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/toast.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ToastService {
    /**
     * @param {?} componentFactoryResolver
     */
    constructor(componentFactoryResolver) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.defaultConfig = {
            position: 'top-right',
            autoclose: true,
            delay: 3
        };
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set config(value) {
        this.defaultConfig = Object.assign(this.defaultConfig, value);
    }
    /**
     * @return {?}
     */
    get config() {
        return this.defaultConfig;
    }
    /**
     * @param {?} viewContainerRef
     * @param {?} component
     * @param {?=} config
     * @return {?}
     */
    init(viewContainerRef, component, config = {}) {
        this.toasts = viewContainerRef;
        this.component = component;
        if (config !== undefined) {
            this.defaultConfig = Object.assign(this.defaultConfig, config);
        }
    }
    /**
     * @param {?} notification
     * @return {?}
     */
    create(notification) {
        /** @type {?} */
        const toast = new Toast(this.component, notification);
        /** @type {?} */
        const action = new Subject();
        /** @type {?} */
        const componentFactory = this.componentFactoryResolver.resolveComponentFactory(toast.component);
        /** @type {?} */
        const componentRef = this.toasts.createComponent(componentFactory);
        /** @type {?} */
        const notificationComponent = ((/** @type {?} */ (componentRef.instance)));
        notificationComponent.viewRef = componentRef.hostView;
        notificationComponent.created = +new Date();
        notificationComponent.data = Object.assign({}, toast.data);
        notificationComponent.action = action;
        return action;
    }
    /**
     * @param {?} toastItemRef
     * @return {?}
     */
    remove(toastItemRef) {
        this.toasts.remove(this.toasts.indexOf(toastItemRef));
    }
}
ToastService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
ToastService.ctorParameters = () => [
    { type: ComponentFactoryResolver }
];
/** @nocollapse */ ToastService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ToastService_Factory() { return new ToastService(ɵɵinject(ComponentFactoryResolver)); }, token: ToastService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    ToastService.prototype.toasts;
    /**
     * @type {?}
     * @private
     */
    ToastService.prototype.component;
    /**
     * @type {?}
     * @private
     */
    ToastService.prototype.defaultConfig;
    /**
     * @type {?}
     * @private
     */
    ToastService.prototype.componentFactoryResolver;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/bootstrap-toast.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class BootstrapToastService {
    /**
     * @param {?} toast
     */
    constructor(toast) {
        this.toast = toast;
    }
    /**
     * Create and fire new toast notification
     *
     * @param {?} message Notification
     * @return {?}
     */
    create(message) {
        return this.toast.create(message);
    }
}
BootstrapToastService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
BootstrapToastService.ctorParameters = () => [
    { type: ToastService }
];
/** @nocollapse */ BootstrapToastService.ngInjectableDef = ɵɵdefineInjectable({ factory: function BootstrapToastService_Factory() { return new BootstrapToastService(ɵɵinject(ToastService)); }, token: BootstrapToastService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    BootstrapToastService.prototype.toast;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/animations/progressBar.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const progressBar = trigger('progress-bar', [
    state('progress', style({ width: '100%' })),
    // transition('* => progress', [
    //   animate('3s'),
    // ]),
    transition('* => progress', animate('{{seconds}}s'), { params: { seconds: 3 } })
]);

/**
 * @fileoverview added by tsickle
 * Generated from: lib/animations/closeToast.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const closeToast = trigger('close-toast', [
    state('close', style({ opacity: 0 })),
    transition('* => close', [
        animate('0.5s')
    ])
]);

/**
 * @fileoverview added by tsickle
 * Generated from: lib/animations/openToastLeft.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const openToastLeft = trigger('open-toast-left', [
    state('open', style({ left: 0 })),
    transition('* => open', [
        animate('0.5s ease-out')
    ])
]);

/**
 * @fileoverview added by tsickle
 * Generated from: lib/animations/openToastRight.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const openToastRight = trigger('open-toast-right', [
    state('open', style({ right: 0 })),
    transition('* => open', [
        animate('0.5s ease-out')
    ])
]);

/**
 * @fileoverview added by tsickle
 * Generated from: lib/notification/notification.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NotificationComponent {
    /**
     * @param {?} toastService
     */
    constructor(toastService) {
        this.toastService = toastService;
        this.isClosed = false;
        this.elapsedMinutes = 0;
        this.autoclose = true;
        this.progressBarStarted = false;
        this.seconds = this.config.delay + 0.5;
    }
    /**
     * @return {?}
     */
    get config() {
        return this.toastService.config;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.autoclose = (this.config.autoclose && this.data.buttons.length === 0);
        console.log(this.autoclose);
        if (this.autoclose) {
            this.interval = setInterval((/**
             * @return {?}
             */
            () => {
                this.onClose();
            }), this.seconds * 1000);
        }
        this._setElapsedMinutes();
        this.interval = setInterval((/**
         * @return {?}
         */
        () => {
            this._setElapsedMinutes();
        }), 1000);
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        clearInterval(this.interval);
    }
    /**
     * @return {?}
     */
    onClose() {
        this.isClosed = true;
    }
    /**
     * @param {?} action
     * @return {?}
     */
    onPushButton(action) {
        this.action.next(action);
        if (action === 'cancel') {
            this.onClose();
        }
    }
    /**
     * @return {?}
     */
    onRemove() {
        if (this.isClosed) {
            this.toastService.remove(this.viewRef);
        }
    }
    /**
     * @return {?}
     */
    onStartProgressBar() {
        this.progressBarStarted = true;
    }
    /**
     * @private
     * @return {?}
     */
    _setElapsedMinutes() {
        /** @type {?} */
        const now = +new Date();
        this.elapsedMinutes = (new Date(now - this.created)).getMinutes();
    }
}
NotificationComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-notification',
                template: "<div \n    *ngIf=\"config.position === 'top-right' || config.position === 'bottom-right'\" \n    class=\"toast toast-right\"\n    role=\"alert\"\n    aria-live=\"assertive\"\n    aria-atomic=\"true\"\n    [@close-toast]=\"!isClosed ? 'open' : 'close'\"\n    [@open-toast-right]=\"'open'\"\n    (@close-toast.done)=\"onRemove()\"\n    (@open-toast-right.done)=\"onStartProgressBar()\">\n    <ng-container *ngTemplateOutlet=\"body\"></ng-container>\n</div>\n<div \n    *ngIf=\"config.position === 'top-left' || config.position === 'bottom-left'\" \n    class=\"toast toast-left\"\n    role=\"alert\"\n    aria-live=\"assertive\"\n    aria-atomic=\"true\"\n    [@close-toast]=\"!isClosed ? 'open' : 'close'\"\n    [@open-toast-left]=\"'open'\"\n    (@close-toast.done)=\"onRemove()\"\n    (@open-toast-left.done)=\"onStartProgressBar()\">\n    <ng-container *ngTemplateOutlet=\"body\"></ng-container>\n</div>\n\n<ng-template #body>\n    <div class=\"toast-header\">\n        <img *ngIf=\"data.icon\"  [src]=\"data.icon\" class=\"icon rounded mr-2\" alt=\"Toast icon\">\n        <strong class=\"mr-auto\">{{ data.title || 'Message' }}</strong>\n        <small \n            *ngIf=\"elapsedMinutes > 0\" \n            class=\"text-muted\">{{ elapsedMinutes }} mins ago</small>\n        <small\n            *ngIf=\"elapsedMinutes === 0\"\n            class=\"text-muted\">Just now</small\n            >\n        <button \n            type=\"button\"\n            class=\"ml-2 mb-1 close\"\n            (click)=\"onClose()\" \n            data-dismiss=\"toast\"\n            aria-label=\"Close\">\n        <span aria-hidden=\"true\">&times;</span>\n        </button>\n    </div>\n    <div class=\"toast-body\">\n        {{ data.message }}\n    </div>\n    <hr *ngIf=\"data.buttons.length > 0\" >\n    <div *ngIf=\"data.buttons.length > 0\"  class=\"toast-body text-right\">\n        <button \n            *ngFor=\"let button of data.buttons\"\n            (click)=\"onPushButton(button.action)\" \n            class=\"btn btn-sm mr-1\"\n            [ngClass]=\"button.class || 'btn-light'\"\n            >{{ button.label }}</button>\n    </div>\n    <div class=\"toast-progress-bar\" *ngIf=\"autoclose\" >\n        <div class=\"progress\">\n            <div class=\"progress-bar\" role=\"progressbar\" [@progress-bar]=\"{ value: progressBarStarted ? 'progress' : '', params: { seconds: config.delay } }\" ></div>\n        </div>\n    </div>\n</ng-template>",
                animations: [
                    closeToast,
                    openToastRight,
                    openToastLeft,
                    progressBar
                ],
                styles: [".toast{position:relative;opacity:1;right:-350px;margin:25px;min-width:320px;max-width:320px;z-index:99999999}.toast.toast-right{right:-350px}.toast.toast-left{left:-350px}.toast .icon{width:18px;height:auto}.toast hr{margin:0}.toast .progress{height:2px;border-radius:0!important;background-color:transparent}"]
            }] }
];
/** @nocollapse */
NotificationComponent.ctorParameters = () => [
    { type: ToastService }
];
NotificationComponent.propDecorators = {
    data: [{ type: Input }],
    viewRef: [{ type: Input }],
    created: [{ type: Input }],
    action: [{ type: Input }]
};
if (false) {
    /** @type {?} */
    NotificationComponent.prototype.data;
    /** @type {?} */
    NotificationComponent.prototype.viewRef;
    /** @type {?} */
    NotificationComponent.prototype.created;
    /** @type {?} */
    NotificationComponent.prototype.action;
    /** @type {?} */
    NotificationComponent.prototype.isClosed;
    /** @type {?} */
    NotificationComponent.prototype.elapsedMinutes;
    /** @type {?} */
    NotificationComponent.prototype.autoclose;
    /** @type {?} */
    NotificationComponent.prototype.progressBarStarted;
    /**
     * @type {?}
     * @private
     */
    NotificationComponent.prototype.interval;
    /**
     * @type {?}
     * @private
     */
    NotificationComponent.prototype.seconds;
    /** @type {?} */
    NotificationComponent.prototype.toastService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/toast.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ToastDirective {
    /**
     * @param {?} viewContainerRef
     */
    constructor(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
}
ToastDirective.decorators = [
    { type: Directive, args: [{
                selector: '[lib-bootstrap-toast-host]'
            },] }
];
/** @nocollapse */
ToastDirective.ctorParameters = () => [
    { type: ViewContainerRef }
];
if (false) {
    /** @type {?} */
    ToastDirective.prototype.viewContainerRef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/bootstrap-toast.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class BootstrapToastComponent {
    /**
     * @param {?} service
     */
    constructor(service) {
        this.service = service;
        this.config = {};
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.service.init(this.toastHost.viewContainerRef, NotificationComponent, this.config);
    }
    /**
     * @return {?}
     */
    ngDoCheck() {
        this.service.config = this.config;
    }
}
BootstrapToastComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-bootstrap-toast',
                template: `
    <div class="notifications" [ngClass]="service.config.position" >
        <ng-template lib-bootstrap-toast-host></ng-template>
    </div>
  `,
                styles: [`
    .notifications {
        position: fixed;
        height: auto;
        z-index: 999999999;
    }
    .notifications.top-right { top: 0px; right: 0px; }
    .notifications.top-left { top: 0px; left: 0px; }
    .notifications.bottom-right { bottom: 0px; right: 0px; }
    .notifications.bottom-left { bottom: 0px; left: 0px; }
    `]
            }] }
];
/** @nocollapse */
BootstrapToastComponent.ctorParameters = () => [
    { type: ToastService }
];
BootstrapToastComponent.propDecorators = {
    config: [{ type: Input }],
    toastHost: [{ type: ViewChild, args: [ToastDirective, { static: true },] }]
};
if (false) {
    /** @type {?} */
    BootstrapToastComponent.prototype.config;
    /** @type {?} */
    BootstrapToastComponent.prototype.toastHost;
    /** @type {?} */
    BootstrapToastComponent.prototype.service;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/bootstrap-toast.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class BootstrapToastModule {
}
BootstrapToastModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    BootstrapToastComponent,
                    ToastDirective,
                    NotificationComponent
                ],
                imports: [
                    CommonModule,
                    BrowserAnimationsModule
                ],
                entryComponents: [
                    NotificationComponent
                ],
                exports: [
                    BootstrapToastComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: bootstrap-toast.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { BootstrapToastComponent, BootstrapToastModule, BootstrapToastService, ToastService as ɵa, ToastDirective as ɵb, NotificationComponent as ɵc, closeToast as ɵd, openToastRight as ɵe, openToastLeft as ɵf, progressBar as ɵg };
//# sourceMappingURL=bootstrap-toast.js.map
