import { Injectable, ComponentFactoryResolver, ɵɵdefineInjectable, ɵɵinject, Component, Input, Directive, ViewContainerRef, ViewChild, NgModule } from '@angular/core';
import { __assign } from 'tslib';
import { Subject } from 'rxjs';
import { trigger, state, style, transition, animate } from '@angular/animations';
import { CommonModule } from '@angular/common';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/toast.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Toast = /** @class */ (function () {
    function Toast(component, data, viewRef) {
        this.component = component;
        this.data = data;
        this.viewRef = viewRef;
    }
    return Toast;
}());
if (false) {
    /** @type {?} */
    Toast.prototype.component;
    /** @type {?} */
    Toast.prototype.data;
    /** @type {?} */
    Toast.prototype.viewRef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/toast.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ToastService = /** @class */ (function () {
    function ToastService(componentFactoryResolver) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.defaultConfig = {
            position: 'top-right',
            autoclose: true,
            delay: 3
        };
    }
    Object.defineProperty(ToastService.prototype, "config", {
        get: /**
         * @return {?}
         */
        function () {
            return this.defaultConfig;
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.defaultConfig = Object.assign(this.defaultConfig, value);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} viewContainerRef
     * @param {?} component
     * @param {?=} config
     * @return {?}
     */
    ToastService.prototype.init = /**
     * @param {?} viewContainerRef
     * @param {?} component
     * @param {?=} config
     * @return {?}
     */
    function (viewContainerRef, component, config) {
        if (config === void 0) { config = {}; }
        this.toasts = viewContainerRef;
        this.component = component;
        if (config !== undefined) {
            this.defaultConfig = Object.assign(this.defaultConfig, config);
        }
    };
    /**
     * @param {?} notification
     * @return {?}
     */
    ToastService.prototype.create = /**
     * @param {?} notification
     * @return {?}
     */
    function (notification) {
        /** @type {?} */
        var toast = new Toast(this.component, notification);
        /** @type {?} */
        var action = new Subject();
        /** @type {?} */
        var componentFactory = this.componentFactoryResolver.resolveComponentFactory(toast.component);
        /** @type {?} */
        var componentRef = this.toasts.createComponent(componentFactory);
        /** @type {?} */
        var notificationComponent = ((/** @type {?} */ (componentRef.instance)));
        notificationComponent.viewRef = componentRef.hostView;
        notificationComponent.created = +new Date();
        notificationComponent.data = __assign({}, toast.data);
        notificationComponent.action = action;
        return action;
    };
    /**
     * @param {?} toastItemRef
     * @return {?}
     */
    ToastService.prototype.remove = /**
     * @param {?} toastItemRef
     * @return {?}
     */
    function (toastItemRef) {
        this.toasts.remove(this.toasts.indexOf(toastItemRef));
    };
    ToastService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    ToastService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver }
    ]; };
    /** @nocollapse */ ToastService.ngInjectableDef = ɵɵdefineInjectable({ factory: function ToastService_Factory() { return new ToastService(ɵɵinject(ComponentFactoryResolver)); }, token: ToastService, providedIn: "root" });
    return ToastService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ToastService.prototype.toasts;
    /**
     * @type {?}
     * @private
     */
    ToastService.prototype.component;
    /**
     * @type {?}
     * @private
     */
    ToastService.prototype.defaultConfig;
    /**
     * @type {?}
     * @private
     */
    ToastService.prototype.componentFactoryResolver;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/bootstrap-toast.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BootstrapToastService = /** @class */ (function () {
    function BootstrapToastService(toast) {
        this.toast = toast;
    }
    /**
     * Create and fire new toast notification
     *
     * @param message Notification
     */
    /**
     * Create and fire new toast notification
     *
     * @param {?} message Notification
     * @return {?}
     */
    BootstrapToastService.prototype.create = /**
     * Create and fire new toast notification
     *
     * @param {?} message Notification
     * @return {?}
     */
    function (message) {
        return this.toast.create(message);
    };
    BootstrapToastService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    BootstrapToastService.ctorParameters = function () { return [
        { type: ToastService }
    ]; };
    /** @nocollapse */ BootstrapToastService.ngInjectableDef = ɵɵdefineInjectable({ factory: function BootstrapToastService_Factory() { return new BootstrapToastService(ɵɵinject(ToastService)); }, token: BootstrapToastService, providedIn: "root" });
    return BootstrapToastService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    BootstrapToastService.prototype.toast;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/animations/progressBar.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var progressBar = trigger('progress-bar', [
    state('progress', style({ width: '100%' })),
    // transition('* => progress', [
    //   animate('3s'),
    // ]),
    transition('* => progress', animate('{{seconds}}s'), { params: { seconds: 3 } })
]);

/**
 * @fileoverview added by tsickle
 * Generated from: lib/animations/closeToast.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var closeToast = trigger('close-toast', [
    state('close', style({ opacity: 0 })),
    transition('* => close', [
        animate('0.5s')
    ])
]);

/**
 * @fileoverview added by tsickle
 * Generated from: lib/animations/openToastLeft.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var openToastLeft = trigger('open-toast-left', [
    state('open', style({ left: 0 })),
    transition('* => open', [
        animate('0.5s ease-out')
    ])
]);

/**
 * @fileoverview added by tsickle
 * Generated from: lib/animations/openToastRight.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var openToastRight = trigger('open-toast-right', [
    state('open', style({ right: 0 })),
    transition('* => open', [
        animate('0.5s ease-out')
    ])
]);

/**
 * @fileoverview added by tsickle
 * Generated from: lib/notification/notification.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NotificationComponent = /** @class */ (function () {
    function NotificationComponent(toastService) {
        this.toastService = toastService;
        this.isClosed = false;
        this.elapsedMinutes = 0;
        this.autoclose = true;
        this.progressBarStarted = false;
        this.seconds = this.config.delay + 0.5;
    }
    Object.defineProperty(NotificationComponent.prototype, "config", {
        get: /**
         * @return {?}
         */
        function () {
            return this.toastService.config;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NotificationComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.autoclose = (this.config.autoclose && this.data.buttons.length === 0);
        console.log(this.autoclose);
        if (this.autoclose) {
            this.interval = setInterval((/**
             * @return {?}
             */
            function () {
                _this.onClose();
            }), this.seconds * 1000);
        }
        this._setElapsedMinutes();
        this.interval = setInterval((/**
         * @return {?}
         */
        function () {
            _this._setElapsedMinutes();
        }), 1000);
    };
    /**
     * @return {?}
     */
    NotificationComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        clearInterval(this.interval);
    };
    /**
     * @return {?}
     */
    NotificationComponent.prototype.onClose = /**
     * @return {?}
     */
    function () {
        this.isClosed = true;
    };
    /**
     * @param {?} action
     * @return {?}
     */
    NotificationComponent.prototype.onPushButton = /**
     * @param {?} action
     * @return {?}
     */
    function (action) {
        this.action.next(action);
        if (action === 'cancel') {
            this.onClose();
        }
    };
    /**
     * @return {?}
     */
    NotificationComponent.prototype.onRemove = /**
     * @return {?}
     */
    function () {
        if (this.isClosed) {
            this.toastService.remove(this.viewRef);
        }
    };
    /**
     * @return {?}
     */
    NotificationComponent.prototype.onStartProgressBar = /**
     * @return {?}
     */
    function () {
        this.progressBarStarted = true;
    };
    /**
     * @private
     * @return {?}
     */
    NotificationComponent.prototype._setElapsedMinutes = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var now = +new Date();
        this.elapsedMinutes = (new Date(now - this.created)).getMinutes();
    };
    NotificationComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-notification',
                    template: "<div \n    *ngIf=\"config.position === 'top-right' || config.position === 'bottom-right'\" \n    class=\"toast toast-right\"\n    role=\"alert\"\n    aria-live=\"assertive\"\n    aria-atomic=\"true\"\n    [@close-toast]=\"!isClosed ? 'open' : 'close'\"\n    [@open-toast-right]=\"'open'\"\n    (@close-toast.done)=\"onRemove()\"\n    (@open-toast-right.done)=\"onStartProgressBar()\">\n    <ng-container *ngTemplateOutlet=\"body\"></ng-container>\n</div>\n<div \n    *ngIf=\"config.position === 'top-left' || config.position === 'bottom-left'\" \n    class=\"toast toast-left\"\n    role=\"alert\"\n    aria-live=\"assertive\"\n    aria-atomic=\"true\"\n    [@close-toast]=\"!isClosed ? 'open' : 'close'\"\n    [@open-toast-left]=\"'open'\"\n    (@close-toast.done)=\"onRemove()\"\n    (@open-toast-left.done)=\"onStartProgressBar()\">\n    <ng-container *ngTemplateOutlet=\"body\"></ng-container>\n</div>\n\n<ng-template #body>\n    <div class=\"toast-header\">\n        <img *ngIf=\"data.icon\"  [src]=\"data.icon\" class=\"icon rounded mr-2\" alt=\"Toast icon\">\n        <strong class=\"mr-auto\">{{ data.title || 'Message' }}</strong>\n        <small \n            *ngIf=\"elapsedMinutes > 0\" \n            class=\"text-muted\">{{ elapsedMinutes }} mins ago</small>\n        <small\n            *ngIf=\"elapsedMinutes === 0\"\n            class=\"text-muted\">Just now</small\n            >\n        <button \n            type=\"button\"\n            class=\"ml-2 mb-1 close\"\n            (click)=\"onClose()\" \n            data-dismiss=\"toast\"\n            aria-label=\"Close\">\n        <span aria-hidden=\"true\">&times;</span>\n        </button>\n    </div>\n    <div class=\"toast-body\">\n        {{ data.message }}\n    </div>\n    <hr *ngIf=\"data.buttons.length > 0\" >\n    <div *ngIf=\"data.buttons.length > 0\"  class=\"toast-body text-right\">\n        <button \n            *ngFor=\"let button of data.buttons\"\n            (click)=\"onPushButton(button.action)\" \n            class=\"btn btn-sm mr-1\"\n            [ngClass]=\"button.class || 'btn-light'\"\n            >{{ button.label }}</button>\n    </div>\n    <div class=\"toast-progress-bar\" *ngIf=\"autoclose\" >\n        <div class=\"progress\">\n            <div class=\"progress-bar\" role=\"progressbar\" [@progress-bar]=\"{ value: progressBarStarted ? 'progress' : '', params: { seconds: config.delay } }\" ></div>\n        </div>\n    </div>\n</ng-template>",
                    animations: [
                        closeToast,
                        openToastRight,
                        openToastLeft,
                        progressBar
                    ],
                    styles: [".toast{position:relative;opacity:1;right:-350px;margin:25px;min-width:320px;max-width:320px;z-index:99999999}.toast.toast-right{right:-350px}.toast.toast-left{left:-350px}.toast .icon{width:18px;height:auto}.toast hr{margin:0}.toast .progress{height:2px;border-radius:0!important;background-color:transparent}"]
                }] }
    ];
    /** @nocollapse */
    NotificationComponent.ctorParameters = function () { return [
        { type: ToastService }
    ]; };
    NotificationComponent.propDecorators = {
        data: [{ type: Input }],
        viewRef: [{ type: Input }],
        created: [{ type: Input }],
        action: [{ type: Input }]
    };
    return NotificationComponent;
}());
if (false) {
    /** @type {?} */
    NotificationComponent.prototype.data;
    /** @type {?} */
    NotificationComponent.prototype.viewRef;
    /** @type {?} */
    NotificationComponent.prototype.created;
    /** @type {?} */
    NotificationComponent.prototype.action;
    /** @type {?} */
    NotificationComponent.prototype.isClosed;
    /** @type {?} */
    NotificationComponent.prototype.elapsedMinutes;
    /** @type {?} */
    NotificationComponent.prototype.autoclose;
    /** @type {?} */
    NotificationComponent.prototype.progressBarStarted;
    /**
     * @type {?}
     * @private
     */
    NotificationComponent.prototype.interval;
    /**
     * @type {?}
     * @private
     */
    NotificationComponent.prototype.seconds;
    /** @type {?} */
    NotificationComponent.prototype.toastService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/toast.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ToastDirective = /** @class */ (function () {
    function ToastDirective(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
    ToastDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[lib-bootstrap-toast-host]'
                },] }
    ];
    /** @nocollapse */
    ToastDirective.ctorParameters = function () { return [
        { type: ViewContainerRef }
    ]; };
    return ToastDirective;
}());
if (false) {
    /** @type {?} */
    ToastDirective.prototype.viewContainerRef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/bootstrap-toast.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BootstrapToastComponent = /** @class */ (function () {
    function BootstrapToastComponent(service) {
        this.service = service;
        this.config = {};
    }
    /**
     * @return {?}
     */
    BootstrapToastComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.service.init(this.toastHost.viewContainerRef, NotificationComponent, this.config);
    };
    /**
     * @return {?}
     */
    BootstrapToastComponent.prototype.ngDoCheck = /**
     * @return {?}
     */
    function () {
        this.service.config = this.config;
    };
    BootstrapToastComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-bootstrap-toast',
                    template: "\n    <div class=\"notifications\" [ngClass]=\"service.config.position\" >\n        <ng-template lib-bootstrap-toast-host></ng-template>\n    </div>\n  ",
                    styles: ["\n    .notifications {\n        position: fixed;\n        height: auto;\n        z-index: 999999999;\n    }\n    .notifications.top-right { top: 0px; right: 0px; }\n    .notifications.top-left { top: 0px; left: 0px; }\n    .notifications.bottom-right { bottom: 0px; right: 0px; }\n    .notifications.bottom-left { bottom: 0px; left: 0px; }\n    "]
                }] }
    ];
    /** @nocollapse */
    BootstrapToastComponent.ctorParameters = function () { return [
        { type: ToastService }
    ]; };
    BootstrapToastComponent.propDecorators = {
        config: [{ type: Input }],
        toastHost: [{ type: ViewChild, args: [ToastDirective, { static: true },] }]
    };
    return BootstrapToastComponent;
}());
if (false) {
    /** @type {?} */
    BootstrapToastComponent.prototype.config;
    /** @type {?} */
    BootstrapToastComponent.prototype.toastHost;
    /** @type {?} */
    BootstrapToastComponent.prototype.service;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/bootstrap-toast.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BootstrapToastModule = /** @class */ (function () {
    function BootstrapToastModule() {
    }
    BootstrapToastModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        BootstrapToastComponent,
                        ToastDirective,
                        NotificationComponent
                    ],
                    imports: [
                        CommonModule,
                        BrowserAnimationsModule
                    ],
                    entryComponents: [
                        NotificationComponent
                    ],
                    exports: [
                        BootstrapToastComponent
                    ]
                },] }
    ];
    return BootstrapToastModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: bootstrap-toast.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { BootstrapToastComponent, BootstrapToastModule, BootstrapToastService, ToastService as ɵa, ToastDirective as ɵb, NotificationComponent as ɵc, closeToast as ɵd, openToastRight as ɵe, openToastLeft as ɵf, progressBar as ɵg };
//# sourceMappingURL=bootstrap-toast.js.map
